/***********************************************************************/
/*                                                                     */
/* RIGI C Parser --- Copyright (C) 1996-1999                           */
/*                    The Rigi Group, University of Victoria           */
/*                                                                     */
/* see the file license.terms for usage and copying policies           */
/*                                                                     */
/* Maintainer: Johannes Martin (jmartin@csr.csc.uvic.ca)               */
/*                                                                     */
/***********************************************************************/
#ifndef __STRING_H__
#define __STRING_H__

class String {
  void init(const char* s, int inc);
protected:
  int increment;
  int allocation;
  int len;
  char *chars;

  /* these functions make sure that the String can hold minLen chars */
  void alloc(int minLen);    /* keeps current content  */
  void realloc(int minLen);  /* looses current content */
public:
  String(int increment = 256);
  String(const char* s, int increment = 256);
  String(const unsigned long l, int increment = 256);
  String(const String& s);
  ~String();

  int length() const { return len; }

  const String& append(const String& s);
  const String& append(const String& s, int num);
  const String& copy(const String& s);
  const String& copy(const String& s, int num);

  const String& operator=(const String& s);
  operator const char*() const;
};

#endif
