/***********************************************************************/
/*                                                                     */
/* RIGI Utilities --- Copyright (C) 1996-1999                          */
/*                    The Rigi Group, University of Victoria           */
/*                                                                     */
/* see the file license.terms for usage and copying policies           */
/*                                                                     */
/* Author: Johannes Martin (jmartin@csr.csc.uvic.ca)                   */
/*                                                                     */
/***********************************************************************/

class UniqueIdentifier {
public:
  static CS_String idForDeclaration(CS_Declaration& d);
};

CS_String UniqueIdentifier::idForDeclaration(CS_Declaration& d) {
  CS_String id;
  try {
    id = d.overloadSignature();
  } catch (CS_Error& e) {
    BEGINTRY
    id = d.id();
    ENDTRY
  }

  CS_SourceLocation *s = d.aSourceLocation();
  if (s) {
    char *theID = new char[id.len() + s->fileName().length() + 30];
    sprintf(theID, "%s^%s^%d^%d", 
	    id.str(), s->fileName().str(), s->line(), s->column());
    id = theID;
    delete[] theID;
  }
  return id;
}
