/***********************************************************************/
/*                                                                     */
/* RIGI C Parser --- Copyright (C) 1996-1999                           */
/*                    The Rigi Group, University of Victoria           */
/*                                                                     */
/* see the file license.terms for usage and copying policies           */
/*                                                                     */
/* Maintainer: Johannes Martin (jmartin@csr.csc.uvic.ca)               */
/*                                                                     */
/***********************************************************************/
// $Author: jmartin $
// $Date: 1999/06/07 15:46:26 $
// $Source: /home/rigi/proj/cvs/Rigi/rigiparse/avl.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// $Author: jmartin $
// $Date: 1999/06/07 15:46:26 $
// $Source: /home/rigi/proj/cvs/Rigi/rigiparse/avl.h,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

// avl.h

#ifndef __AVL_H__
#define __AVL_H__

extern const int INVALID;

typedef int Avlset;

int	GetInfo( Avlset, const char *s );
int	SetInfo( Avlset, const char *s, int info );

const char* GetString( Avlset, int info );
int	SetString( Avlset, int info, const char *s );

Avlset	NewSet( int );
int	PrintSet( Avlset );
int	FreeSet( Avlset );

/*
	Description:

	NewSet(i) returns a handle to an empty new set. INVALID
		is returned if cannot get one. If neglected to
		use, the one set is identified by 0.
		Parameter indicates if string or info is key.

	PrintSet() dumps out the current set, with size info.
	FreeSet() frees the current set.

	GetInfo( a,s ) returns the integer info associated with s,
		or returns INVALID and stores s and INVALID.
	SetInfo( a,s,i ) resets the info of s to i, and returns
		INVALID if s is new to the set, or else the old info.

	GetString( a,i ) gets the string associated with i in set a,
		or returns NULL.
	SetString( a,i,s ) resets the string associated with set a and
		info i, to s, and returns NULL if s is new, or else
		the original string.

	Info must be non-negative integers!
*/
#endif
